CodiousProef/CodiousProef/Models/ErrorViewModel.cs
using System;

namespace CodiousProef.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

CodiousProef/CodiousProef/Controllers/ApiController.cs
using System;
using System.IdentityModel.Tokens.Jwt;
using System.Security.Claims;
using System.Text;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.IdentityModel.Tokens;

namespace NetCoreJWTAuth.App.Controllers
{
    [Authorize]
    [Produces("application/json")]
    [Route("api")]
    public class ApiController : Controller
    {
        private readonly IConfiguration _configuration;

        public ApiController(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        [HttpGet("Test")]
        public IActionResult Test()
        {
            var userName = User.Identity.Name;

            return Ok($"Super secret content, I hope you've got clearance for this {userName}...");
        }

        [Authorize]
        [HttpPost("DeleteUser")]
        public IActionResult DeleteUser(string username)
        {
            // go wild, delete the user, do what you have to...
            return Ok("Deleted");
        }

        [AllowAnonymous]
        [HttpPost]
        public IActionResult RequestToken([FromBody] TokenRequest request)
        {
            if (request.Username == "Jon" && request.Password == "Again, not for production use, DEMO ONLY!")
            {
                var claims = new[]
                {
                    new Claim(ClaimTypes.Name, request.Username),
                    new Claim("CompletedBasicTraining", ""),
                    //new Claim(CustomClaimTypes.EmploymentCommenced,
                    //            new DateTime(2017,12,1).ToString(),
                    //            ClaimValueTypes.DateTime)
                };

                var key = new SymmetricSecurityKey(Encoding.UTF8.GetBytes(_configuration["SecurityKey"]));
                var creds = new SigningCredentials(key, SecurityAlgorithms.HmacSha256);

                var token = new JwtSecurityToken(
                    issuer: "yourdomain.com",
                    audience: "yourdomain.com",
                    claims: claims,
                    expires: DateTime.Now.AddMinutes(30),
                    signingCredentials: creds);

                return Ok(new
                {
                    token = new JwtSecurityTokenHandler().WriteToken(token)
                });
            }

            return BadRequest("Could not verify username and password");
        }

    }

    public class TokenRequest
    {
        public string Username { get; set; }
        public string Password { get; set; }
    }
}

CodiousProef/CodiousProef/Controllers/ClientController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web.Http.Cors;
using CodiousProef.Data;
using CodiousProef.Repositories;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace CodiousProef.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class ClientController : ControllerBase
    {
        private readonly IClientRepository _clientRepository;
        public ClientController(IClientRepository clientRepository)
        {
            _clientRepository = clientRepository;
        }
        // GET: api/Client
        [HttpGet]
        public IEnumerable<Client> Get()
        {
            return _clientRepository.GetAllClients();
        }

        // GET: api/Client/5
        [HttpGet("{id}", Name = "Get")]
        public Client Get(int id)
        {
            return _clientRepository.GetClient(id);
        }

        // POST: api/Client
        [HttpPost]
        public void Post(Client client)
        {
            _clientRepository.CreateClient(client);
            

        }

        // PUT: api/Client/5
        [HttpPut("{id}")]
        public void Put(int id, Client client)
        {
            if(id == client.Id)
            {
                _clientRepository.UpdateClient(client);
            }
        }

        // DELETE: api/ApiWithActions/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
            _clientRepository.DeleteClient(id);
        }
    }
}

CodiousProef/CodiousProef/Controllers/ConsultantController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using CodiousProef.Repositories;
using CodiousProef.Data;

namespace CodiousProef.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class ConsultantController : ControllerBase
    {
        private readonly IConsultantRepository _consultantRepository;
        public ConsultantController(IConsultantRepository consultantRepository)
        {
            _consultantRepository = consultantRepository;
        }

        // GET: api/Consultant
        [HttpGet]
        public IEnumerable<Consultant> Get()
        {
           return _consultantRepository.GetAllConsultants();
        }

        // GET: api/Consultant/5
        [HttpGet("{id}", Name = "GetConsultant")]
        public Consultant Get(int id)
        {
            return _consultantRepository.GetConsultant(id);
        }

        // POST: api/Consultant
        [HttpPost]
        public void Post(Consultant consultant)
        {
            _consultantRepository.CreateConsultant(consultant);
        }

        // PUT: api/Consultant/5
        [HttpPut("{id}")]
        public void Put(int id, Consultant consultant)
        {
            if(id == consultant.Id)
            {
                _consultantRepository.UpdateConsultant(consultant);
            }
        }

        // DELETE: api/ApiWithActions/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
            _consultantRepository.DeleteConsultant(id);
        }
    }
}

CodiousProef/CodiousProef/Controllers/ProjectController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using CodiousProef.Repositories;
using CodiousProef.Data;

namespace CodiousProef.Controllers
{

    [Route("api/[controller]")]
    [ApiController]
    public class ProjectController : ControllerBase
    {
        private readonly IProjectRepository _projectRepository;
        public ProjectController(IProjectRepository projectRepository)
        {
            _projectRepository = projectRepository;
        }
        // GET: api/Project
        [HttpGet]
        public IEnumerable<Project> Get()
        {
            return _projectRepository.GetAllProjects();
        }

        // GET: api/Project/5
        [HttpGet("{id}", Name = "GetProject")]
        public Project Get(int id)
        {
            return _projectRepository.GetProject(id);
        }

        // POST: api/Project
        [HttpPost]
        public void Post(Project project)
        {
            
            _projectRepository.CreateProject(project);
        }

        // PUT: api/Project/5
        [HttpPut("{id}")]
        public void Put(int id, Project project)
        {
            if (id == project.Id)
            {
                _projectRepository.UpdateProject(project);
            }

        }

        // DELETE: api/ApiWithActions/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
            _projectRepository.DeleteProject(id);
        }
    }
}

CodiousProef/CodiousProef/Controllers/UsersController.cs
using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc;
using AutoMapper;
using System.IdentityModel.Tokens.Jwt;
using CodiousProef.Data;
using Microsoft.Extensions.Options;
using System.Text;
using Microsoft.IdentityModel.Tokens;
using System.Security.Claims;
using Microsoft.AspNetCore.Authorization;


namespace CodiousProef.Controllers
{
    [Authorize]
    [Route("api/[controller]")]
    [ApiController]
    public class UsersController : ControllerBase
    {

    }
}

CodiousProef/CodiousProef/Views/Client/Create.cshtml
@model CodiousProef.Data.Client

@{
    ViewData["Title"] = "Create";
}

<h1>Create</h1>

<h4>Client</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Function" class="control-label"></label>
                <input asp-for="Function" class="form-control" />
                <span asp-validation-for="Function" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

CodiousProef/CodiousProef/Views/Client/Details.cshtml
@model CodiousProef.Data.Client

@{
    ViewData["Title"] = "Details";
}

<h1>Details</h1>

<div>
    <h4>Client</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Function)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Function)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.Id">Edit</a> |
    <a asp-action="Index">Back to List</a>
</div>

CodiousProef/CodiousProef/Views/Client/Index.cshtml
@model IEnumerable<CodiousProef.Data.Client>

@{
    ViewData["Title"] = "Index";
}

<h1>Index</h1>

<p>
    <a asp-action="Create">Create New</a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Name)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Function)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Name)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Function)
            </td>
            <td>
                <a asp-action="Edit" asp-route-id="@item.Id">Edit</a> |
                <a asp-action="Details" asp-route-id="@item.Id">Details</a> |
                <a asp-action="Delete" asp-route-id="@item.Id">Delete</a>
            </td>
        </tr>
}
    </tbody>
</table>

CodiousProef/CodiousProef/Views/Consultant/Create.cshtml
@model CodiousProef.Data.Consultant

@{
    ViewData["Title"] = "Create";
}

<h1>Create</h1>

<h4>Consultant</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Uurtarief" class="control-label"></label>
                <input asp-for="Uurtarief" class="form-control" />
                <span asp-validation-for="Uurtarief" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Email" class="control-label"></label>
                <input asp-for="Email" class="form-control" />
                <span asp-validation-for="Email" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Adres.Street" class="control-label"></label>
                <input asp-for="Adres.Street" class="form-control" />
                <span asp-validation-for="Adres.Street" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Adres.Number" class="control-label"></label>
                <input asp-for="Adres.Number" class="form-control" />
                <span asp-validation-for="Adres.Number" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Adres.ZipCode" class="control-label"></label>
                <input asp-for="Adres.ZipCode" class="form-control" />
                <span asp-validation-for="Adres.ZipCode" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

CodiousProef/CodiousProef/Views/Consultant/Delete.cshtml
@model CodiousProef.Data.Consultant

@{
    ViewData["Title"] = "Delete";
}

<h1>Delete</h1>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Consultant</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Uurtarief)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Uurtarief)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Email)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Email)
        </dd>
    </dl>
    
    <form asp-action="Delete">
        <input type="hidden" asp-for="Id" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>

CodiousProef/CodiousProef/Views/Consultant/Details.cshtml
@model CodiousProef.Data.Consultant

@{
    ViewData["Title"] = "Details";
}

<h1>Details</h1>

<div>
    <h4>Consultant</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Uurtarief)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Uurtarief)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Email)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Email)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Adres.Street)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Adres.Street)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Adres.Number)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Adres.Number)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Adres.ZipCode)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Adres.ZipCode)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Adres.Place)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Adres.Place)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.Id">Edit</a> |
    <a asp-action="Index">Back to List</a>
</div>

CodiousProef/CodiousProef/Views/Consultant/Edit.cshtml
@model CodiousProef.Data.Consultant

@{
    ViewData["Title"] = "Edit";
}

<h1>Edit</h1>

<h4>Consultant</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="Id" />
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Uurtarief" class="control-label"></label>
                <input asp-for="Uurtarief" class="form-control" />
                <span asp-validation-for="Uurtarief" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Email" class="control-label"></label>
                <input asp-for="Email" class="form-control" />
                <span asp-validation-for="Email" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Adres.Street" class="control-label"></label>
                <input asp-for="Adres.Street" class="form-control" />
                <span asp-validation-for="Adres.Street" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Adres.Number" class="control-label"></label>
                <input asp-for="Adres.Number" class="form-control" />
                <span asp-validation-for="Adres.Number" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Adres.ZipCode" class="control-label"></label>
                <input asp-for="Adres.ZipCode" class="form-control" />
                <span asp-validation-for="Adres.ZipCode" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Adres.Place" class="control-label"></label>
                <input asp-for="Adres.Place" class="form-control" />
                <span asp-validation-for="Adres.Place" class="text-danger"></span>
            </div>

            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

CodiousProef/CodiousProef/Views/Consultant/Index.cshtml
@model IEnumerable<CodiousProef.Data.Consultant>

@{
    ViewData["Title"] = "Index";
}

<h1>Index</h1>

<p>
    <a asp-action="Create">Create New</a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Name)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Uurtarief)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Email)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Adres.Place)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Name)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Uurtarief)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Email)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Adres.Place)
            </td>
            <td>
                <a asp-action="Edit" asp-route-id="@item.Id">Edit</a> |
                <a asp-action="Details" asp-route-id="@item.Id">Details</a> |
                <a asp-action="Delete" asp-route-id="@item.Id">Delete</a>
            </td>
        </tr>
}
    </tbody>
</table>

CodiousProef/CodiousProef/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

CodiousProef/CodiousProef/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - CodiousProef</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
              crossorigin="anonymous"
              integrity="sha256-eSi1q2PG6J7g7ib17yAaWMcrr5GrtohYChqibrV7PBE="/>
    </environment>
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Codious</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <partial name="_LoginPartial" />
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Client" asp-action="Index">Clients</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Consultant" asp-action="Index">Consultants</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <partial name="_CookieConsentPartial" />
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2019 - CodiousProef - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=">
        </script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.bundle.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha256-E/V4cWE4qvAeO5MOhjtGtqDzPndRO1LBk8lJ/PR7CA4=">
        </script>
    </environment>
    <script src="~/js/site.js" asp-append-version="true"></script>

    @RenderSection("Scripts", required: false)
</body>
</html>